{
  this is a short test for the compiler unit
}

program ide_test;

  uses
     crt,dos,errors,globals,systems,compiler;

  function error_handler(w : terrorconst) : boolean;far;

    begin
       writeln('error_handler called');
       { we stop always the compiler }
       error_handler:=true;
    end;

  procedure scsw;far;

    begin
       unitsearchpath:=getenv(target_info.unit_env);
       { we don't set other switches }
    end;

  { cheap solution from pp.pas }
  function print_status(const status : tcompilestatus) : boolean;far;

    begin
       print_status:=false;
       if not(quiet) then
         begin
            if (abslines=1) then
              case language of
                 'E' : writeln(memavail div 1024,' kB free');
                 'D' : writeln(memavail div 1024,' kB frei');
              end;
            if (status.currentline mod 100=0) then
               begin
                  { ESC stops the compiler }
                  if keypressed then
                    begin
                       if readkey=#27 then
                         print_status:=false;
                    end;
                  case language of
                     'E' : write(status.currentline,' lines','  ',memavail div 1024,' kB free');
                     'D' : write(status.currentline,' Zeilen','  ',memavail div 1024,' kB frei');
                  end;
{$ifdef tp}
                  if (use_big) then
                    case language of
                       'E' : write(', ',symbolstream.getsize div 1024,' kB EMS used');
                       'D' : write(', ',symbolstream.getsize div 1024,' kB EMS benutzt');
                    end;
{$endif}
                  writeln
               end;
         end;
    end;

  var
     p : ^string;

  begin
     { we use only one simple error handler }
     do_warning:=error_handler;
     do_error:=error_handler;
     { no handler for internal errors, I'am too lazy to do this
     do_internalerror:=error_handler; }
     do_fatalerror:=error_handler;
     setcompilerswitches:=scsw;

     { tests the heap saver }
     writeln(memavail);
     new(p);
     p^:='Hallo';
     writeln(memavail);

     compile('TESTSUIT\TNONE.PP',print_status);

     { also a test }
     writeln(memavail);
     writeln(p^);
  end.
